/* Hintergrund-Kommandointerpreter fr Kommunikation ber UART */

#include "StdTypes.h"
#include "conv.h"
#include "gio.h"
#include "cmd.h"

char   Kommandozeile[80];
char*  Cpt;


/* hier den eigenen Report formulieren */
void DoEigenenReport(word wo)
{ String_Out("ANTWORT ",wo);
  /* hier weitere Ausgaben nach deinem Gusto */

  CRLF_Out(wo);
}

/* hier wird die ganze Zeile einfach durchgewinkt */
DoDurchwinken(word wo)
{ String_Out(Kommandozeile,wo);
  CRLF_Out(wo);
}



void DoCommand (char* Pzeile, word wo)
{ char  c;

  Cpt = Pzeile;


  if (match("REPORT",&Cpt))     { DoEigenenReport(wo); return;}
  if (match("ANTWORT",&Cpt))    { DoDurchwinken(wo);  return;}

  /* hier ist Platz fr weitere Kommandos */



  if (!*Cpt) return;

  String_Out("wat? ", wo);
  while (*Cpt)
  { c = *Cpt;
    Char_Out(c, wo);
    ++Cpt;
  }
  CRLF_Out(wo);
}




/*************************************************************************/

int kzi;

void InitCmd (word wo)
{  long L;

   L = sizeof(Kommandozeile);
   while (L) Kommandozeile[--L] = 0;
   kzi = L;
   Char_Out('>', wo);
}



  /* Kommandozeile hereinholen */
void Talk (word wo)
{ char c;

  if (RxAvail(wo))
  { c =  GetChar(wo);
    if (c==10) return;
    if (c==13)
    { CRLF_Out(wo);
      DoCommand (Kommandozeile, wo);
      InitCmd(wo);
    }
    else
    { if (kzi>=(sizeof(Kommandozeile)-1)) return;
      if (c==8)
      { Char_Out(8, wo);
        Char_Out(' ', wo);
        Char_Out(8, wo);
        if (kzi) --kzi;
        Kommandozeile[kzi]=0;
      }
      else
      { Char_Out(c, wo);
        Kommandozeile[kzi++] = c;
        Kommandozeile[kzi] = 0;
      }
    }
  }
}


  /* ende */
